Index: GTP/trunk/Lib/Vis/Preprocessing/src/VspBspTree.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VspBspTree.cpp	(revision 1772)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VspBspTree.cpp	(revision 1773)
@@ -2128,6 +2128,6 @@
 	//-- pvs rendering heuristics
 
-	const int lowerPvsLimit = mViewCellsManager->GetMinPvsSize();
-	const int upperPvsLimit = mViewCellsManager->GetMaxPvsSize();
+	const float lowerPvsLimit = (float)mViewCellsManager->GetMinPvsSize();
+	const float upperPvsLimit = (float)mViewCellsManager->GetMaxPvsSize();
 
 	// only render cost heuristics or combined with standard deviation
Index: GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.h	(revision 1768)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.h	(revision 1773)
@@ -43,5 +43,6 @@
 
   struct PvsFilterStatistics {
-	PvsFilterStatistics(): mAvgFilterRadius(0.0f), mLocalFilterCount(0), mGlobalFilterCount(0) {}
+	PvsFilterStatistics(): 
+  mAvgFilterRadius(0.0f), mLocalFilterCount(0), mGlobalFilterCount(0) {}
 	float mAvgFilterRadius;
 	int mLocalFilterCount;
@@ -613,5 +614,7 @@
 	/** Sets exporter color.
 	*/
-	virtual void ExportColor(Exporter *exporter, ViewCell *vc, const bool colorCode) const;
+	virtual void ExportColor(Exporter *exporter, 
+							 ViewCell *vc, 
+							 const bool colorCode) const;
 	
 	/** Creates meshes from the view cells.
@@ -669,4 +672,6 @@
 	ViewCellsTree *mViewCellsTree;
 	
+	std::vector<int> mStrategies;
+
 	/** if the values in the view cell leaves and the interiors are up to date
 		this is meant for lazy storing of the pvs, where only a scalar indicating
Index: GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 1772)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 1773)
@@ -119,4 +119,17 @@
 	Environment::GetSingleton()->GetStringValue("ViewCells.samplingType", buf);
 
+	// mix of sampling strategies
+	if (0)
+	{
+		mStrategies.push_back(SamplingStrategy::OBJECT_BASED_DISTRIBUTION);
+		mStrategies.push_back(SamplingStrategy::SPATIAL_BOX_BASED_DISTRIBUTION);
+		mStrategies.push_back(SamplingStrategy::REVERSE_OBJECT_BASED_DISTRIBUTION);
+	}
+	else
+	{
+		mStrategies.push_back(SamplingStrategy::VIEWSPACE_BORDER_BASED_DISTRIBUTION);
+		mStrategies.push_back(SamplingStrategy::REVERSE_VIEWSPACE_BORDER_BASED_DISTRIBUTION);
+	}
+
 	// sampling type for view cells construction samples
 	if (strcmp(buf, "object") == 0)
@@ -391,21 +404,6 @@
 	cout << "view cell construction: casting " << mInitialSamples << " initial samples ... " << endl;
 
-	// mix of sampling strategies
-	vector<int> strategies;
-	
-	if (0)
-	{
-		strategies.push_back(SamplingStrategy::OBJECT_BASED_DISTRIBUTION);
-		strategies.push_back(SamplingStrategy::SPATIAL_BOX_BASED_DISTRIBUTION);
-		strategies.push_back(SamplingStrategy::REVERSE_OBJECT_BASED_DISTRIBUTION);
-	}
-	else
-	{
-		strategies.push_back(SamplingStrategy::VIEWSPACE_BORDER_BASED_DISTRIBUTION);
-		//strategies.push_back(SamplingStrategy::REVERSE_VIEWSPACE_BORDER_BASED_DISTRIBUTION);
-	}
-
 	// cast initial samples
-	CastPassSamples(mInitialSamples, strategies, initialSamples);
+	CastPassSamples(mInitialSamples, mStrategies, initialSamples);
 
 	cout << "finished in " << TimeDiff(startTime, GetTime()) * 1e-3 << " secs" << endl;
@@ -479,5 +477,5 @@
 		// cast new samples
 		numSamples += CastPassSamples(mSamplesPerPass, 
-									  strategies,
+									  mStrategies,
 									  constructionSamples);
 
@@ -521,5 +519,5 @@
 	cout << "casting " << mPostProcessSamples << " post processing samples ... ";
 	
-	CastPassSamples(mPostProcessSamples, strategies, postProcessSamples);
+	CastPassSamples(mPostProcessSamples, mStrategies, postProcessSamples);
 
 	cout << "finished" << endl;
@@ -566,6 +564,6 @@
 		if (0)
 		{
-			strategies.clear();
-			strategies.push_back(SamplingStrategy::VIEWCELL_BORDER_BASED_DISTRIBUTION);
+			mStrategies.clear();
+			mStrategies.push_back(SamplingStrategy::VIEWCELL_BORDER_BASED_DISTRIBUTION);
 		}
 
@@ -575,5 +573,5 @@
 		VssRayContainer visSamples;
 		int numSamples = CastPassSamples(mVisualizationSamples,
-										 strategies, 
+										 mStrategies, 
 										 visSamples);
 
@@ -994,19 +992,4 @@
 	}
 
-	// mix of sampling strategies
-	vector<int> strategies;
-	
-	if (0)
-	{
-		strategies.push_back(SamplingStrategy::OBJECT_BASED_DISTRIBUTION);
-		strategies.push_back(SamplingStrategy::SPATIAL_BOX_BASED_DISTRIBUTION);
-		strategies.push_back(SamplingStrategy::REVERSE_OBJECT_BASED_DISTRIBUTION);
-	}
-	else
-	{
-		strategies.push_back(SamplingStrategy::VIEWSPACE_BORDER_BASED_DISTRIBUTION);
-		strategies.push_back(SamplingStrategy::REVERSE_VIEWSPACE_BORDER_BASED_DISTRIBUTION);
-	}
-
 	cout << "finished" << endl;
     cout << "Evaluating view cell partition ... " << endl;
@@ -1025,5 +1008,5 @@
 		Debug << "casting " << samplesPerPass << " samples ... ";
 
-		CastPassSamples(samplesPerPass, strategies, evaluationSamples);
+		CastPassSamples(samplesPerPass, mStrategies, evaluationSamples);
 		
 		castSamples += samplesPerPass;
@@ -5994,20 +5977,5 @@
 	Debug << "view cell stats prefix: " << statsPrefix << endl;
 
-    // mix of sampling strategies
-	vector<int> strategies;
-	
-	if (0)
-	{
-		strategies.push_back(SamplingStrategy::OBJECT_BASED_DISTRIBUTION);
-		strategies.push_back(SamplingStrategy::SPATIAL_BOX_BASED_DISTRIBUTION);
-		strategies.push_back(SamplingStrategy::REVERSE_OBJECT_BASED_DISTRIBUTION);
-	}
-	else
-	{
-		strategies.push_back(SamplingStrategy::VIEWSPACE_BORDER_BASED_DISTRIBUTION);
-		strategies.push_back(SamplingStrategy::REVERSE_VIEWSPACE_BORDER_BASED_DISTRIBUTION);
-	}
-
-	cout << "reseting pvs ... ";
+    cout << "reseting pvs ... ";
 		
 	// reset pvs and start over from zero
@@ -6030,5 +5998,5 @@
 		Debug << "casting " << samplesPerPass << " samples ... ";
 
-		CastPassSamples(samplesPerPass, strategies, evaluationSamples);
+		CastPassSamples(samplesPerPass, mStrategies, evaluationSamples);
 		
 		castSamples += samplesPerPass;