Index: GTP/trunk/Lib/Geom/shared/GTGeometry/GTGeometry.sln
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/GTGeometry.sln	(revision 774)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/GTGeometry.sln	(revision 1788)
@@ -1,4 +1,8 @@
 Microsoft Visual Studio Solution File, Format Version 8.00
 Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "GTGeometry", "GTGeometry.vcproj", "{A1B6E932-F612-4CBC-9260-DF91CD4E748F}"
+	ProjectSection(ProjectDependencies) = postProject
+	EndProjectSection
+EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "GeoLodLibraryDLL", "GeoLodLibraryDLL.vcproj", "{84625A65-ECC9-4DD3-B02E-1C21C5766D72}"
 	ProjectSection(ProjectDependencies) = postProject
 	EndProjectSection
@@ -14,4 +18,8 @@
 		{A1B6E932-F612-4CBC-9260-DF91CD4E748F}.Release.ActiveCfg = Release|Win32
 		{A1B6E932-F612-4CBC-9260-DF91CD4E748F}.Release.Build.0 = Release|Win32
+		{84625A65-ECC9-4DD3-B02E-1C21C5766D72}.Debug.ActiveCfg = Debug|Win32
+		{84625A65-ECC9-4DD3-B02E-1C21C5766D72}.Debug.Build.0 = Debug|Win32
+		{84625A65-ECC9-4DD3-B02E-1C21C5766D72}.Release.ActiveCfg = Release|Win32
+		{84625A65-ECC9-4DD3-B02E-1C21C5766D72}.Release.Build.0 = Release|Win32
 	EndGlobalSection
 	GlobalSection(ExtensibilityGlobals) = postSolution
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoLodLibraryDLL.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoLodLibraryDLL.h	(revision 1788)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoLodLibraryDLL.h	(revision 1788)
@@ -0,0 +1,20 @@
+// El siguiente bloque ifdef muestra la forma estándar de crear macros que facilitan 
+// la exportación de archivos DLL. Todos los archivos de este archivo DLL se compilan con el símbolo GEOLODLIBRARYDLL_EXPORTS
+// definido en la línea de comandos. Este símbolo no se debe definir en ningún proyecto
+// que utilice este archivo DLL. De este modo, otros proyectos cuyos archivos de código fuente incluyan el archivo
+// interpreta que las funciones GEOLODLIBRARYDLL_API se importan de un archivo DLL, mientras que este archivo DLL interpreta los símbolos
+// definidos en esta macro como si fueran exportados.
+/*#ifdef GEOLODLIBRARYDLL_EXPORTS
+#define GEOLODLIBRARYDLL_API __declspec(dllexport)
+#else
+#define GEOLODLIBRARYDLL_API __declspec(dllimport)
+#endif*/
+
+// The project defines by default a GEOLODLIBRARYDLL_API __declspec(dllexport)
+#ifndef GEOLODLIBRARYDLL_API
+#define GEOLODLIBRARYDLL_API __declspec(dllimport)
+#endif
+
+#include <GeoMeshLoader.h>
+#include <GeoLodStripsLibrary.h>
+#include <GeoLodTreeLibrary.h>
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoLodObject.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoLodObject.h	(revision 1526)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoLodObject.h	(revision 1788)
@@ -1,4 +1,8 @@
 #ifndef _GEOLODOBJECT
 #define _GEOLODOBJECT
+
+#ifndef GEOLODLIBRARYDLL_API
+#define GEOLODLIBRARYDLL_API
+#endif
 
 namespace Geometry
@@ -6,5 +10,5 @@
 	class IndexData;
 
-	class LodObject
+	class GEOLODLIBRARYDLL_API LodObject
 	{
 	public:
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoLodStripsLibrary.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoLodStripsLibrary.h	(revision 1560)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoLodStripsLibrary.h	(revision 1788)
@@ -81,5 +81,5 @@
 	};
 
-	class LodStripsLibrary : public Geometry::LodObject
+	class GEOLODLIBRARYDLL_API LodStripsLibrary : public Geometry::LodObject
 	{
 		private:
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoMeshLoader.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoMeshLoader.h	(revision 1083)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoMeshLoader.h	(revision 1788)
@@ -107,5 +107,5 @@
 	
 	/// Mesh class interface
-	class GeoMeshLoader
+	class GEOLODLIBRARYDLL_API GeoMeshLoader
 	{
 		private:
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoLodLibraryDLL.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoLodLibraryDLL.cpp	(revision 1788)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoLodLibraryDLL.cpp	(revision 1788)
@@ -0,0 +1,22 @@
+// GeoLodLibraryDLL.cpp: define el punto de entrada de la aplicación DLL.
+//
+
+#include "../include/GeoLodLibraryDLL.h"
+#define WIN32_LEAN_AND_MEAN
+#include <windows.h>
+
+BOOL APIENTRY DllMain( HANDLE hModule, 
+                       DWORD  ul_reason_for_call, 
+                       LPVOID lpReserved
+					 )
+{
+	switch (ul_reason_for_call)
+	{
+	case DLL_PROCESS_ATTACH:
+	case DLL_THREAD_ATTACH:
+	case DLL_THREAD_DETACH:
+	case DLL_PROCESS_DETACH:
+		break;
+	}
+    return TRUE;
+}
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/GTGeometry.vcproj
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/GTGeometry.vcproj	(revision 1782)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/GTGeometry.vcproj	(revision 1788)
@@ -21,5 +21,5 @@
 				Optimization="0"
 				AdditionalIncludeDirectories=".\src\libs;.\include;.\src\libs\vmi\include;.\src\libs\ntl"
-				PreprocessorDefinitions="WIN32;_DEBUG;_LIB;GLEW_STATIC"
+				PreprocessorDefinitions="WIN32;_DEBUG;_LIB;GLEW_STATIC;GEOLODLIBRARYDLL_API="
 				MinimalRebuild="TRUE"
 				ExceptionHandling="TRUE"
@@ -65,5 +65,5 @@
 				Optimization="2"
 				AdditionalIncludeDirectories=".\src\libs;.\include;.\src\libs\vmi\include;.\src\libs\ntl"
-				PreprocessorDefinitions="WIN32;NDEBUG;_LIB;GLEW_STATIC"
+				PreprocessorDefinitions="WIN32;NDEBUG;_LIB;GLEW_STATIC;GEOLODLIBRARYDLL_API="
 				MinimalRebuild="TRUE"
 				BasicRuntimeChecks="0"
@@ -386,7 +386,4 @@
 			<File
 				RelativePath=".\include\GeoMesh.h">
-			</File>
-			<File
-				RelativePath=".\include\GeoMeshLoader.h">
 			</File>
 			<File
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/GeoLodLibraryDLL.vcproj
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/GeoLodLibraryDLL.vcproj	(revision 1788)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/GeoLodLibraryDLL.vcproj	(revision 1788)
@@ -0,0 +1,171 @@
+<?xml version="1.0" encoding="Windows-1252"?>
+<VisualStudioProject
+	ProjectType="Visual C++"
+	Version="7.10"
+	Name="GeoLodLibraryDLL"
+	ProjectGUID="{84625A65-ECC9-4DD3-B02E-1C21C5766D72}"
+	Keyword="Win32Proj">
+	<Platforms>
+		<Platform
+			Name="Win32"/>
+	</Platforms>
+	<Configurations>
+		<Configuration
+			Name="Debug|Win32"
+			OutputDirectory="build/Debug"
+			IntermediateDirectory="build/Debug"
+			ConfigurationType="2"
+			CharacterSet="2">
+			<Tool
+				Name="VCCLCompilerTool"
+				Optimization="0"
+				AdditionalIncludeDirectories="include"
+				PreprocessorDefinitions="WIN32;_DEBUG;_WINDOWS;_USRDLL;GEOLODLIBRARYDLL_EXPORTS;GEOLODLIBRARYDLL_API=__declspec(dllexport)"
+				MinimalRebuild="TRUE"
+				BasicRuntimeChecks="3"
+				RuntimeLibrary="1"
+				UsePrecompiledHeader="0"
+				WarningLevel="3"
+				Detect64BitPortabilityProblems="TRUE"
+				DebugInformationFormat="4"/>
+			<Tool
+				Name="VCCustomBuildTool"/>
+			<Tool
+				Name="VCLinkerTool"
+				OutputFile="$(OutDir)/GeoLodLibraryDLL_d.dll"
+				LinkIncremental="2"
+				GenerateDebugInformation="TRUE"
+				ProgramDatabaseFile="$(OutDir)/GeoLodLibraryDLL.pdb"
+				SubSystem="2"
+				ImportLibrary="$(OutDir)/GeoLodLibraryDLL_d.lib"
+				TargetMachine="1"/>
+			<Tool
+				Name="VCMIDLTool"/>
+			<Tool
+				Name="VCPostBuildEventTool"
+				CommandLine="xcopy /Y H:\jesus\GameTools\SVN\GTP\trunk\Lib\Geom\shared\GTGeometry\build\Debug\GeoLodLibraryDLL_d.dll H:\jesus\shark3d\shark3d\bin\win32_vc7x1\debug\"/>
+			<Tool
+				Name="VCPreBuildEventTool"/>
+			<Tool
+				Name="VCPreLinkEventTool"/>
+			<Tool
+				Name="VCResourceCompilerTool"/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"/>
+			<Tool
+				Name="VCWebDeploymentTool"/>
+			<Tool
+				Name="VCManagedWrapperGeneratorTool"/>
+			<Tool
+				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+		</Configuration>
+		<Configuration
+			Name="Release|Win32"
+			OutputDirectory="build/Release"
+			IntermediateDirectory="Release"
+			ConfigurationType="2"
+			CharacterSet="2">
+			<Tool
+				Name="VCCLCompilerTool"
+				AdditionalIncludeDirectories="include"
+				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;_USRDLL;GEOLODLIBRARYDLL_EXPORTS;GEOLODLIBRARYDLL_API=__declspec(dllexport)"
+				RuntimeLibrary="0"
+				UsePrecompiledHeader="0"
+				WarningLevel="3"
+				Detect64BitPortabilityProblems="TRUE"
+				DebugInformationFormat="3"/>
+			<Tool
+				Name="VCCustomBuildTool"/>
+			<Tool
+				Name="VCLinkerTool"
+				OutputFile="$(OutDir)/GeoLodLibraryDLL.dll"
+				LinkIncremental="1"
+				GenerateDebugInformation="TRUE"
+				SubSystem="2"
+				OptimizeReferences="2"
+				EnableCOMDATFolding="2"
+				ImportLibrary="$(OutDir)/GeoLodLibraryDLL.lib"
+				TargetMachine="1"/>
+			<Tool
+				Name="VCMIDLTool"/>
+			<Tool
+				Name="VCPostBuildEventTool"
+				CommandLine="xcopy /Y H:\jesus\GameTools\SVN\GTP\trunk\Lib\Geom\shared\GTGeometry\build\Release\GeoLodLibraryDLL.dll H:\jesus\shark3d\shark3d\bin\win32_vc7x1\release"/>
+			<Tool
+				Name="VCPreBuildEventTool"/>
+			<Tool
+				Name="VCPreLinkEventTool"/>
+			<Tool
+				Name="VCResourceCompilerTool"/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"/>
+			<Tool
+				Name="VCWebDeploymentTool"/>
+			<Tool
+				Name="VCManagedWrapperGeneratorTool"/>
+			<Tool
+				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+		</Configuration>
+	</Configurations>
+	<References>
+	</References>
+	<Files>
+		<Filter
+			Name="Source Files"
+			Filter="cpp;c;cxx;def;odl;idl;hpj;bat;asm;asmx"
+			UniqueIdentifier="{4FC737F1-C7A5-4376-A066-2A32D752A2FF}">
+			<File
+				RelativePath="src\libs\leaves\foliage.cpp">
+			</File>
+			<File
+				RelativePath="src\GeoLodLibraryDLL.cpp">
+			</File>
+			<File
+				RelativePath="src\GeoLodStripsLibrary.cpp">
+			</File>
+			<File
+				RelativePath="src\GeoLodTreeLibrary.cpp">
+			</File>
+			<File
+				RelativePath="src\GeoMesh.cpp">
+			</File>
+			<File
+				RelativePath="src\GeoMeshLoader.cpp">
+			</File>
+			<File
+				RelativePath="src\GeoSerializer.cpp">
+			</File>
+			<File
+				RelativePath="src\GeoSubMesh.cpp">
+			</File>
+			<File
+				RelativePath="src\GeoTreeSimpSequence.cpp">
+			</File>
+			<File
+				RelativePath="src\GeoVertexBuffer.cpp">
+			</File>
+			<File
+				RelativePath="src\libs\leaves\Leaf.cpp">
+			</File>
+		</Filter>
+		<Filter
+			Name="Header Files"
+			Filter="h;hpp;hxx;hm;inl;inc;xsd"
+			UniqueIdentifier="{93995380-89BD-4b04-88EB-625FBE52EBFB}">
+			<File
+				RelativePath="include\GeoLodLibraryDLL.h">
+			</File>
+		</Filter>
+		<Filter
+			Name="Resource Files"
+			Filter="rc;ico;cur;bmp;dlg;rc2;rct;bin;rgs;gif;jpg;jpeg;jpe;resx"
+			UniqueIdentifier="{67DA6AB6-F800-4c08-8B7A-83BB121AAD01}">
+		</Filter>
+	</Files>
+	<Globals>
+	</Globals>
+</VisualStudioProject>